/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.EmpresaDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Administrador
 */
@Repository("empresaDAO")
public class EmpresaHibernateDAO extends GenericHibernateDAO<Empresa, Integer>
        implements EmpresaDAO {

    @Autowired
    public EmpresaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<Empresa> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.addOrder(Order.asc("nombempresa"));

        return c.list();
    }

    public List<Empresa> buscar(String nombempresa, Boolean indExterna, Short indTipo) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("nombempresa", nombempresa));
        c.add(Restrictions.eq("indExterna", indExterna));
        c.add(Restrictions.eq("indTipo", indTipo));

        return c.list();
    }

    public List<Empresa> buscarTodosExceto(Integer... idEmpresa) {
        Criteria c = this.makeCriteria();
        for (Integer id : idEmpresa) {
            c.add(Restrictions.ne("empresaId", id));
        }
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.addOrder(Order.asc("nombempresa"));
        return c.list();

    }

    public List<Empresa> obtenerIndExternoFalse() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("indExterna", Boolean.FALSE));

        c.addOrder(Order.asc("nombempresa"));

        return c.list();
    }

    public List<Empresa> obtenerIndTipo1() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("indTipo", new Short("1")));
        
        //Nao Buscar Empresa todas
        c.add(Restrictions.ne("empresaId", -1));

        c.addOrder(Order.asc("nombempresa"));

        return c.list();
    }

    public List<Empresa> obtenerIndTipo2() {
         Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("indTipo", new Short("2")));

        //Nao Buscar Empresa todas
        c.add(Restrictions.ne("empresaId", -1));

        c.addOrder(Order.asc("nombempresa"));

        return c.list();
    }
}
