/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.MotivoCancelacionDAO;
import com.rjconsultores.ventaboletos.entidad.MotivoCancelacion;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Rafius
 */
@Repository("motivoCancelacionDAO")
public class MotivoCancelacionHibernateDAO extends GenericHibernateDAO<MotivoCancelacion, Integer>
        implements MotivoCancelacionDAO {

    @Autowired
    public MotivoCancelacionHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<MotivoCancelacion> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.addOrder(Order.asc("descmotivo"));

        return c.list();
    }

    public List<MotivoCancelacion> buscar(String descmotivo, String tipomotivo) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("descmotivo", descmotivo));
        c.add(Restrictions.eq("tipomotivo", tipomotivo));

        return c.list();
    }

    public List<MotivoCancelacion> obtenerTodosTipoMotivoB() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("tipomotivo", "B"));
        c.addOrder(Order.asc("descmotivo"));

        return c.list();
    }

    public List<MotivoCancelacion> obtenerTodosEspecificos(Integer[] motivos) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.in("motivocancelacionId", motivos));
        c.addOrder(Order.asc("descmotivo"));

        return c.list();
    }
}
