/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.SequenceGenerator;

/**
 *
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "CANCELACION_CTRL_SEQ", sequenceName = "CANCELACION_CTRL_SEQ", allocationSize = 1)
@Table(name = "CANCELACION_CTRL")
public class CancelacionCtrl implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "CANCELACION_CTRL_SEQ")
    @Column(name = "CANCELACIONCTRL_ID")
    private Integer cancelacionctrlId;
    @Column(name = "TIEMPOPREVSALIDA")
    @Temporal(TemporalType.TIME)
    private Date tiempoprevsalida;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "PUNTOVENTA_ID", referencedColumnName = "PUNTOVENTA_ID")
    @ManyToOne
    private PuntoVenta puntoVenta;
    @JoinColumn(name = "ORIGEN_ID", referencedColumnName = "PARADA_ID")
    @ManyToOne
    private Parada paradaOrigem;
    @JoinColumn(name = "DESTINO_ID", referencedColumnName = "PARADA_ID")
    @ManyToOne
    private Parada paradaDestino;
    @JoinColumn(name = "MARCA_ID", referencedColumnName = "MARCA_ID")
    @ManyToOne
    private Marca marca;
    @ManyToOne
    @JoinColumn(name = "MOTIVOCANCELACION_ID", referencedColumnName = "MOTIVOCANCELACION_ID")
    private MotivoCancelacion motivoCancelacion;
    @OneToMany(mappedBy = "cancelacionCtrl", cascade = CascadeType.ALL)
    private List<CancelacionCargo> cancelacionCargoList;

    public CancelacionCtrl() {
    }

    public CancelacionCtrl(Integer cancelacionctrlId) {
        this.cancelacionctrlId = cancelacionctrlId;
    }

    public Integer getCancelacionctrlId() {
        return cancelacionctrlId;
    }

    public void setCancelacionctrlId(Integer cancelacionctrlId) {
        this.cancelacionctrlId = cancelacionctrlId;
    }

    public Date getTiempoprevsalida() {
        return tiempoprevsalida;
    }

    public void setTiempoprevsalida(Date tiempoprevsalida) {
        this.tiempoprevsalida = tiempoprevsalida;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public PuntoVenta getPuntoVenta() {
        return puntoVenta;
    }

    public void setPuntoVenta(PuntoVenta puntoVenta) {
        this.puntoVenta = puntoVenta;
    }

    public Parada getParadaDestino() {
        return paradaDestino;
    }

    public void setParadaDestino(Parada paradaDestino) {
        this.paradaDestino = paradaDestino;
    }

    public Parada getParadaOrigem() {
        return paradaOrigem;
    }

    public void setParadaOrigem(Parada paradaOrigem) {
        this.paradaOrigem = paradaOrigem;
    }

    public Marca getMarca() {
        return marca;
    }

    public void setMarca(Marca marca) {
        this.marca = marca;
    }

    public MotivoCancelacion getMotivoCancelacion() {
        return motivoCancelacion;
    }

    public void setMotivoCancelacion(MotivoCancelacion motivoCancelacion) {
        this.motivoCancelacion = motivoCancelacion;
    }

    public List<CancelacionCargo> getCancelacionCargoList() {
        List<CancelacionCargo> tmp = new ArrayList<CancelacionCargo>();
        if (cancelacionCargoList != null) {
            for (CancelacionCargo cc : this.cancelacionCargoList) {
                if (cc.getActivo()) {
                    tmp.add(cc);
                }
            }
        }

        return tmp;
    }

    public void setCancelacionCargoList(List<CancelacionCargo> cancelacionCargoList) {
        this.cancelacionCargoList = cancelacionCargoList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (cancelacionctrlId != null ? cancelacionctrlId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof CancelacionCtrl)) {
            return false;
        }
        CancelacionCtrl other = (CancelacionCtrl) object;
        if ((this.cancelacionctrlId == null && other.cancelacionctrlId != null) || (this.cancelacionctrlId != null && !this.cancelacionctrlId.equals(other.cancelacionctrlId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.CancelacionCtrl[cancelacionctrlId=" + cancelacionctrlId + "]";
    }
}
