/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Rafius
 */
@Entity

@SequenceGenerator(name = "PROD_RUTA_SEQ", sequenceName = "PROD_RUTA_SEQ", allocationSize = 1)
@Table(name = "PROD_RUTA")
public class ProdRuta implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "PROD_RUTA_SEQ")
    @Column(name = "PRODRUTA_ID")
    private Integer prodrutaId;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "RUTA_ID", referencedColumnName = "RUTA_ID")
    @ManyToOne
    private Ruta ruta;
    @JoinColumn(name = "PRODUCTOSERVICIO_ID", referencedColumnName = "PRODUCTOSERVICIO_ID")
    @ManyToOne
    private ProductoServicio productoServicio;

    public ProdRuta() {
    }

    public ProdRuta(Integer prodrutaId) {
        this.prodrutaId = prodrutaId;
    }

    public Integer getProdrutaId() {
        return prodrutaId;
    }

    public void setProdrutaId(Integer prodrutaId) {
        this.prodrutaId = prodrutaId;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public Ruta getRuta() {
        return ruta;
    }

    public void setRuta(Ruta ruta) {
        this.ruta = ruta;
    }

    public ProductoServicio getProductoServicio() {
        return productoServicio;
    }

    public void setProductoServicio(ProductoServicio productoServicio) {
        this.productoServicio = productoServicio;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (prodrutaId != null ? prodrutaId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ProdRuta)) {
            return false;
        }
        ProdRuta other = (ProdRuta) object;
        if ((this.prodrutaId == null && other.prodrutaId != null) || (this.prodrutaId != null && !this.prodrutaId.equals(other.prodrutaId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.utilerias.ProdRuta[prodrutaId=" + prodrutaId + "]";
    }
}
