/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.SequenceGenerator;

/**
 *
 * @author Administrador
 */
@Entity
@SequenceGenerator(name = "RESERVACION_CLASE_SEQ", sequenceName = "RESERVACION_CLASE_SEQ", allocationSize = 1)
@Table(name = "RESERVACION_CLASE")
public class ReservacionClase implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "RESERVACION_CLASE_SEQ")
    @Column(name = "RESERVACIONCLASE_ID")
    private Integer reservacionclaseId;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "RESERVACIONCTRL_ID", referencedColumnName = "RESERVACIONCTRL_ID")
    @ManyToOne
    private ReservacionCtrl reservacionCtrl;
    @JoinColumn(name = "CLASESERVICIO_ID", referencedColumnName = "CLASESERVICIO_ID")
    @ManyToOne
    private ClaseServicio claseServicio;

    public ReservacionClase() {
    }

    public ReservacionClase(Integer reservacionclaseId) {
        this.reservacionclaseId = reservacionclaseId;
    }

    public Integer getReservacionclaseId() {
        return reservacionclaseId;
    }

    public void setReservacionclaseId(Integer reservacionclaseId) {
        this.reservacionclaseId = reservacionclaseId;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public ReservacionCtrl getReservacionCtrl() {
        return reservacionCtrl;
    }

    public void setReservacionCtrl(ReservacionCtrl reservacionCtrl) {
        this.reservacionCtrl = reservacionCtrl;
    }

    public ClaseServicio getClaseServicio() {
        return claseServicio;
    }

    public void setClaseServicio(ClaseServicio claseServicio) {
        this.claseServicio = claseServicio;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final ReservacionClase other = (ReservacionClase) obj;
        if (this.activo != other.activo && (this.activo == null || !this.activo.equals(other.activo))) {
            return false;
        }
        if (this.reservacionCtrl != other.reservacionCtrl && (this.reservacionCtrl == null || !this.reservacionCtrl.equals(other.reservacionCtrl))) {
            return false;
        }
        if (this.claseServicio != other.claseServicio && (this.claseServicio == null || !this.claseServicio.equals(other.claseServicio))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 3;
        hash = 97 * hash + (this.activo != null ? this.activo.hashCode() : 0);
        hash = 97 * hash + (this.reservacionCtrl != null ? this.reservacionCtrl.hashCode() : 0);
        hash = 97 * hash + (this.claseServicio != null ? this.claseServicio.hashCode() : 0);
        return hash;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.ReservacionClase[reservacionclaseId=" + reservacionclaseId + "]";
    }
}
