/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.SequenceGenerator;

/**
 *
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "ROL_OPERATIVO_SEQ", sequenceName = "ROL_OPERATIVO_SEQ", allocationSize=1)
@Table(name = "ROL_OPERATIVO")
public class RolOperativo implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "ROL_OPERATIVO_SEQ")
    @Column(name = "ROLOPERATIVO_ID")
    private Integer roloperativoId;
    @Column(name = "DESCROLOPERATIVO")
    private String descroloperativo;
    @Column(name = "TIEMPOPREVIO")
    @Temporal(TemporalType.TIMESTAMP)
    private Date tiempoprevio;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @OneToMany(mappedBy = "rolOperativo")
    private List<EsquemaCorrida> esquemaCorridaList;
    @JoinColumn(name = "DIAGRAMAAUTOBUS_ID", referencedColumnName = "DIAGRAMAAUTOBUS_ID")
    @ManyToOne
    private DiagramaAutobus diagramaAutobus;

    public RolOperativo() {
    }

    public RolOperativo(Integer roloperativoId) {
        this.roloperativoId = roloperativoId;
    }

    public Integer getRoloperativoId() {
        return roloperativoId;
    }

    public void setRoloperativoId(Integer roloperativoId) {
        this.roloperativoId = roloperativoId;
    }

    public String getDescroloperativo() {
        return descroloperativo;
    }

    public void setDescroloperativo(String descroloperativo) {
        this.descroloperativo = descroloperativo;
    }

    public Date getTiempoprevio() {
        return tiempoprevio;
    }

    public void setTiempoprevio(Date tiempoprevio) {
        this.tiempoprevio = tiempoprevio;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public List<EsquemaCorrida> getEsquemaCorridaList() {
        return esquemaCorridaList;
    }

    public void setEsquemaCorridaList(List<EsquemaCorrida> esquemaCorridaList) {
        this.esquemaCorridaList = esquemaCorridaList;
    }

    public DiagramaAutobus getDiagramaAutobus() {
        return diagramaAutobus;
    }

    public void setDiagramaAutobus(DiagramaAutobus diagramaAutobus) {
        this.diagramaAutobus = diagramaAutobus;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (roloperativoId != null ? roloperativoId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof RolOperativo)) {
            return false;
        }
        RolOperativo other = (RolOperativo) object;
        if ((this.roloperativoId == null && other.roloperativoId != null) || (this.roloperativoId != null && !this.roloperativoId.equals(other.roloperativoId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return this.getDescroloperativo();
    }
}
