/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Administrador
 */
@Entity
@Table(name = "SECRETARIA")
@SequenceGenerator(name = "SECRETARIA_SEQ", sequenceName = "SECRETARIA_SEQ", allocationSize = 1)
public class Secretaria implements Serializable {

    public static final Short PRECIO_TOTAL = 1;
    public static final Short PRECIO_MENOS_DESCUENTO = 2;
    public static final Short DESCUENTO_COBRAR = 3;
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "SECRETARIA_SEQ")
    @Column(name = "SECRETARIA_ID")
    private Integer secretariaId;
    @Column(name = "DESCSECRETARIA")
    private String descsecretaria;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @Column(name = "CVESECRETARIA")
    private String cvesecretaria;
    @Column(name = "VALIDAFOLIO")
    private Boolean validafolio;
    @Column(name = "IMPRIMEPRECIO")
    private Short imprimeprecio;
    @OneToMany(cascade = CascadeType.ALL)
    @JoinColumn(name = "SECRETARIA_ID")
    private List<CuponSecretaria> lsCuponSecretaria;

    public Secretaria() {
    }

    public Secretaria(Integer secretariaId) {
        this.secretariaId = secretariaId;
    }

    public Integer getSecretariaId() {
        return secretariaId;
    }

    public void setSecretariaId(Integer secretariaId) {
        this.secretariaId = secretariaId;
    }

    public String getDescsecretaria() {
        return descsecretaria;
    }

    public void setDescsecretaria(String descsecretaria) {
        this.descsecretaria = descsecretaria;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public String getCvesecretaria() {
        return cvesecretaria;
    }

    public void setCvesecretaria(String cvesecretaria) {
        this.cvesecretaria = cvesecretaria;
    }

    public Boolean getValidafolio() {
        return validafolio;
    }

    public void setValidafolio(Boolean validafolio) {
        this.validafolio = validafolio;
    }

    public Short getImprimeprecio() {
        return imprimeprecio;
    }

    public void setImprimeprecio(Short imprimeprecio) {
        this.imprimeprecio = imprimeprecio;
    }

    public List<CuponSecretaria> getLsCuponSecretaria() {

        List<CuponSecretaria> tmp = new ArrayList<CuponSecretaria>();
        if (lsCuponSecretaria != null) {
            for (CuponSecretaria cp : this.lsCuponSecretaria) {
                if (cp.getActivo()) {
                    tmp.add(cp);
                }
            }
        }

        return tmp;
    }

    public void setLsCuponSecretaria(List<CuponSecretaria> lsCuponSecretaria) {
        this.lsCuponSecretaria = lsCuponSecretaria;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (secretariaId != null ? secretariaId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Secretaria)) {
            return false;
        }
        Secretaria other = (Secretaria) object;
        if ((this.secretariaId == null && other.secretariaId != null) || (this.secretariaId != null && !this.secretariaId.equals(other.secretariaId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.Secretaria[secretariaId=" + secretariaId + "]";
    }
}
