/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Rafius
 */
@Entity
@Table(name = "TIPO_CAMBIO_CTRL")
@SequenceGenerator(name = "TIPO_CAMBIO_CTRL_SEQ", sequenceName = "TIPO_CAMBIO_CTRL_SEQ", allocationSize = 1)
public class TipoCambioCtrl implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "TIPO_CAMBIO_CTRL_SEQ")
    @Column(name = "TIPOCAMBIOCTRL_ID")
    private Integer tipocambioctrlId;
    @Column(name = "IMPORTECAMBIO")
    private BigDecimal importecambio;
    @Column(name = "FECAPLICACION")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecaplicacion;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @OneToMany(cascade = CascadeType.ALL)
    @JoinColumn(name = "TIPOCAMBIOCTRL_ID", referencedColumnName = "TIPOCAMBIOCTRL_ID")
    private List<TipoCambioCiudad> tipoCambioCiudadList;
    @JoinColumn(name = "MONEDADESTINO_ID", referencedColumnName = "MONEDA_ID")
    @ManyToOne
    private Moneda monedaDestino;
    @JoinColumn(name = "MONEDAORIGEN_ID", referencedColumnName = "MONEDA_ID")
    @ManyToOne
    private Moneda monedaOrigen;

    public TipoCambioCtrl() {
    }

    public TipoCambioCtrl(Integer tipocambioctrlId) {
        this.tipocambioctrlId = tipocambioctrlId;
    }

    public Integer getTipocambioctrlId() {
        return tipocambioctrlId;
    }

    public void setTipocambioctrlId(Integer tipocambioctrlId) {
        this.tipocambioctrlId = tipocambioctrlId;
    }

    public BigDecimal getImportecambio() {
        return importecambio;
    }

    public void setImportecambio(BigDecimal importecambio) {
        this.importecambio = importecambio;
    }

    public Date getFecaplicacion() {
        return fecaplicacion;
    }

    public void setFecaplicacion(Date fecaplicacion) {
        this.fecaplicacion = fecaplicacion;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public List<TipoCambioCiudad> getTipoCambioCiudadList() {
        List<TipoCambioCiudad> pcList = new ArrayList<TipoCambioCiudad>();
        for (TipoCambioCiudad pc : this.tipoCambioCiudadList) {
            if (pc.getActivo() == Boolean.TRUE) {
                pcList.add(pc);
            }
        }
        return pcList;
    }

    public void setTipoCambioCiudadList(List<TipoCambioCiudad> tipoCambioCiudadList) {
        this.tipoCambioCiudadList = tipoCambioCiudadList;
    }

    public Moneda getMonedaDestino() {
        return monedaDestino;
    }

    public void setMonedaDestino(Moneda monedaDestino) {
        this.monedaDestino = monedaDestino;
    }

    public Moneda getMonedaOrigen() {
        return monedaOrigen;
    }

    public void setMonedaOrigen(Moneda monedaOrigen) {
        this.monedaOrigen = monedaOrigen;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (tipocambioctrlId != null ? tipocambioctrlId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof TipoCambioCtrl)) {
            return false;
        }
        TipoCambioCtrl other = (TipoCambioCtrl) object;
        if ((this.tipocambioctrlId == null && other.tipocambioctrlId != null) || (this.tipocambioctrlId != null && !this.tipocambioctrlId.equals(other.tipocambioctrlId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.dao.TipoCambioCtrl[tipocambioctrlId=" + tipocambioctrlId + "]";
    }
}
