/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Shiro
 */
@Entity
@SequenceGenerator(name = "TIPO_EMPLEADO_SEQ", sequenceName = "TIPO_EMPLEADO_SEQ", allocationSize = 1)
@Table(name = "TIPO_EMPLEADO")
public class TipoEmpleado implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "TIPO_EMPLEADO_SEQ")
    @Column(name = "TIPOEMPLEADO_ID")
    private Integer tipoEmpleadoId;
    @Column(name = "DESCTIPO")
    private String descTipo;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @OneToMany(mappedBy = "tipoEmpleado")
    private List<Empleado> empleadoList;

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public String getDescTipo() {
        return descTipo;
    }

    public void setDescTipo(String descTipo) {
        this.descTipo = descTipo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getTipoEmpleadoId() {
        return tipoEmpleadoId;
    }

    public void setTipoEmpleadoId(Integer tipoEmpleadoId) {
        this.tipoEmpleadoId = tipoEmpleadoId;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (tipoEmpleadoId != null ? tipoEmpleadoId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof TipoEmpleado)) {
            return false;
        }
        TipoEmpleado other = (TipoEmpleado) object;
        if ((this.tipoEmpleadoId == null && other.tipoEmpleadoId != null) || (this.tipoEmpleadoId != null && !this.tipoEmpleadoId.equals(other.tipoEmpleadoId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        //return "com.rjconsultores.ventaboletos.entidad.GrupoCortesias[grupocortesiaId=" + grupocortesiaId + "]";
        return this.getDescTipo();
    }
}
