/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.CategoriaDAO;
import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.entidad.CategoriaCtrl;
import com.rjconsultores.ventaboletos.service.CategoriaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("categoriaService")
public class CategoriaServiceImpl implements CategoriaService {

    @Autowired
    private CategoriaDAO categoriaDAO;

    public List<Categoria> obtenerTodos() {
        return categoriaDAO.obtenerTodos();
    }

    public Categoria obtenerID(Integer id) {
        return categoriaDAO.obtenerID(id);
    }

    @Transactional
    public Categoria suscribir(Categoria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaDAO.suscribir(entidad);
    }

    @Transactional
    public Categoria actualizacion(Categoria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Categoria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        categoriaDAO.actualizacion(entidad);
    }

    public List<Categoria> buscar(String desccategoria) {
        return categoriaDAO.buscar(desccategoria);
    }

    public List<Categoria> obtenerTodasCategoriasVisibles() {
        List<Categoria> listCategoriasVisibles = new ArrayList<Categoria>();
        List<Categoria> lsCategorias = obtenerTodos();

        for (Categoria c : lsCategorias) {
            boolean esVisible = true;
            for (Integer id : CategoriaCtrl.idsCategoriasNoVisible) {
                if (id.equals(c.getCategoriaId())) {
                    esVisible = false;
                }
            }
            if (esVisible) {
                listCategoriasVisibles.add(c);
            }

        }
        return listCategoriasVisibles;
    }
}
