/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.CorridaCtrlDAO;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.CorridaCtrl;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.service.CorridaCtrlService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("corridaCtrlService")
public class CorridaCtrlServiceImpl implements CorridaCtrlService {

    @Autowired
    private CorridaCtrlDAO corridaCtrlDAO;
    private static Logger log = Logger.getLogger(CorridaCtrlServiceImpl.class);

    public List<CorridaCtrl> obtenerTodos() {
        return corridaCtrlDAO.obtenerTodos();
    }

    public CorridaCtrl obtenerID(Integer id) {
        return corridaCtrlDAO.obtenerID(id);
    }

    @Transactional
    public CorridaCtrl suscribir(CorridaCtrl entidad) {
    	Integer usuarioId = 1;
    	if (UsuarioLogado.getUsuarioLogado()!=null){
    		usuarioId = UsuarioLogado.getUsuarioLogado().getUsuarioId();
    	}
        entidad.setUsuarioId(usuarioId);
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return corridaCtrlDAO.suscribir(entidad);
    }

    @Transactional
    public CorridaCtrl actualizacion(CorridaCtrl entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return corridaCtrlDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(CorridaCtrl entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        corridaCtrlDAO.actualizacion(entidad);
    }

    public CorridaCtrl buscar(Ruta ruta, ClaseServicio claseServicio, Marca marca, Date horario, boolean pisoExtra) {
        return corridaCtrlDAO.buscar(ruta, claseServicio, marca, horario, pisoExtra);
    }

}
