/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.EmpleadoDAO;
import com.rjconsultores.ventaboletos.entidad.Empleado;
import com.rjconsultores.ventaboletos.service.EmpleadoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 *
 * @author Shiro
 */
@Service("empleadoService")
public class EmpleadoServiceImpl implements EmpleadoService {

    @Autowired
    private EmpleadoDAO empleadoDAO;

    public List<Empleado> obtenerTodos() {
        return empleadoDAO.obtenerTodos();
    }

    public Empleado obtenerID(Integer id) {
        return empleadoDAO.obtenerID(id);
    }

    public Empleado suscribir(Empleado entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return empleadoDAO.suscribir(entidad);
    }

    public Empleado actualizacion(Empleado entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return empleadoDAO.actualizacion(entidad);
    }

    public void borrar(Empleado entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        empleadoDAO.actualizacion(entidad);
    }

    public List<Empleado> pesquisaClave(String empleadoClave) {
        return empleadoDAO.pesquisaClave(empleadoClave);
    }
}
