/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingAsiento;
import com.rjconsultores.ventaboletos.entidad.PricingCategoria;
import com.rjconsultores.ventaboletos.entidad.PricingClase;
import com.rjconsultores.ventaboletos.entidad.PricingCorrida;
import com.rjconsultores.ventaboletos.entidad.PricingDia;
import com.rjconsultores.ventaboletos.entidad.PricingImporte;
import com.rjconsultores.ventaboletos.entidad.PricingMarca;
import com.rjconsultores.ventaboletos.entidad.PricingMercado;
import com.rjconsultores.ventaboletos.entidad.PricingOcupacion;
import com.rjconsultores.ventaboletos.entidad.PricingPuntoVenta;
import com.rjconsultores.ventaboletos.entidad.PricingRuta;
import com.rjconsultores.ventaboletos.entidad.PricingTipoPtoVta;
import com.rjconsultores.ventaboletos.entidad.PricingVigencia;
import com.rjconsultores.ventaboletos.service.PricingService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("pricingService")
public class PricingServiceImpl implements PricingService {

    @Autowired
    private PricingDAO pricingDAO;

    public List<Pricing> obtenerTodos() {
        return pricingDAO.obtenerTodos();
    }

    public Pricing obtenerID(Integer id) {
        return pricingDAO.obtenerID(id);
    }

    @Transactional
    public Pricing suscribir(Pricing entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingDAO.suscribir(entidad);
    }

    @Transactional
    public Pricing actualizacion(Pricing entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Pricing entidad) {

        entidad = obtenerID(entidad.getPricingId());

        for (PricingAsiento pricing : entidad.getPricingAsientoList()) {
            pricing.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pricing.setFecmodif(Calendar.getInstance().getTime());
            pricing.setActivo(Boolean.FALSE);
        }

        for (PricingCategoria pricing : entidad.getPricingCategoriaList()) {
            pricing.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pricing.setFecmodif(Calendar.getInstance().getTime());
            pricing.setActivo(Boolean.FALSE);
        }

        for (PricingClase pricing : entidad.getPricingClaseList()) {
            pricing.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pricing.setFecmodif(Calendar.getInstance().getTime());
            pricing.setActivo(Boolean.FALSE);
        }

        for (PricingCorrida pricing : entidad.getPricingCorridaList()) {
            pricing.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pricing.setFecmodif(Calendar.getInstance().getTime());
            pricing.setActivo(Boolean.FALSE);
        }

        for (PricingDia pricing : entidad.getPricingDiaList()) {
            pricing.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pricing.setFecmodif(Calendar.getInstance().getTime());
            pricing.setActivo(Boolean.FALSE);
        }

        for (PricingImporte pricing : entidad.getPricingImporteList()) {
            pricing.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pricing.setFecmodif(Calendar.getInstance().getTime());
            pricing.setActivo(Boolean.FALSE);
        }

        for (PricingMarca pricing : entidad.getPricingMarcaList()) {
            pricing.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pricing.setFecmodif(Calendar.getInstance().getTime());
            pricing.setActivo(Boolean.FALSE);
        }

        for (PricingMercado pricing : entidad.getPricingMercadoList()) {
            pricing.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pricing.setFecmodif(Calendar.getInstance().getTime());
            pricing.setActivo(Boolean.FALSE);
        }

        for (PricingOcupacion pricing : entidad.getPricingOcupacionList()) {
            pricing.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pricing.setFecmodif(Calendar.getInstance().getTime());
            pricing.setActivo(Boolean.FALSE);
        }

        for (PricingPuntoVenta pricing : entidad.getPricingPuntoventaList()) {
            pricing.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pricing.setFecmodif(Calendar.getInstance().getTime());
            pricing.setActivo(Boolean.FALSE);
        }

        for (PricingRuta pricing : entidad.getPricingRutaList()) {
            pricing.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pricing.setFecmodif(Calendar.getInstance().getTime());
            pricing.setActivo(Boolean.FALSE);
        }

        for (PricingTipoPtoVta pricing : entidad.getPricingTipoptovtaList()) {
            pricing.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pricing.setFecmodif(Calendar.getInstance().getTime());
            pricing.setActivo(Boolean.FALSE);
        }

        for (PricingVigencia pricing : entidad.getPricingVigenciaList()) {
            pricing.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pricing.setFecmodif(Calendar.getInstance().getTime());
            pricing.setActivo(Boolean.FALSE);
        }

        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        pricingDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrarFisico(Pricing entidad) {
        borrar(entidad);
    }

    public List<Pricing> buscar(String nombPricing, Empresa empresa,
            Short cantboleto, Integer cantdiasanticipacion,
            BigDecimal descuentoporcentaje, BigDecimal descuentoporcredondo) {
        return pricingDAO.buscar(nombPricing, empresa, cantboleto, cantdiasanticipacion,
                descuentoporcentaje, descuentoporcredondo);
    }

    public List<Pricing> buscarPorNombre(String nombPricing) {
        return pricingDAO.buscarPorNombre(nombPricing);
    }
}
