/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.RutaCombinacionDAO;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.RutaCombinacion;
import com.rjconsultores.ventaboletos.entidad.Tramo;
import com.rjconsultores.ventaboletos.service.RutaCombinacionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("rutaCombinacionaService")
public class RutaCombinacionServiceImpl implements RutaCombinacionService {

    @Autowired
    private RutaCombinacionDAO rutaCombinacionaDAO;

    public List<RutaCombinacion> obtenerTodos() {
        return rutaCombinacionaDAO.obtenerTodos();
    }

    public RutaCombinacion obtenerID(Integer id) {
        return rutaCombinacionaDAO.obtenerID(id);
    }

    @Transactional
    public RutaCombinacion suscribir(RutaCombinacion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return rutaCombinacionaDAO.suscribir(entidad);
    }

    @Transactional
    public RutaCombinacion actualizacion(RutaCombinacion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return rutaCombinacionaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(RutaCombinacion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        rutaCombinacionaDAO.actualizacion(entidad);
    }

    public boolean busquedaRutaTramo(Ruta ruta, Tramo tramo, Boolean ativo) {
        return rutaCombinacionaDAO.busquedaRutaTramo(ruta, tramo, ativo);
    }

    public RutaCombinacion busquedaTramoRutaTramo(Ruta ruta, Tramo trBuscaOrigemDestino) {
        return rutaCombinacionaDAO.busquedaTramoRutaTramo(ruta, trBuscaOrigemDestino);
    }

    public void ativar(RutaCombinacion rcExiste) {
        rcExiste.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        rcExiste.setFecmodif(Calendar.getInstance().getTime());
        rcExiste.setActivo(Boolean.TRUE);

        rutaCombinacionaDAO.actualizacion(rcExiste);
    }

    public Tramo busqueda(Ruta ruta, Parada origen, Parada destino) {
        return rutaCombinacionaDAO.busqueda(ruta, origen, destino);
    }

    public RutaCombinacion busquedaTramoRutaOrigemDestino(Ruta ruta, Parada origem, Parada destino) {
        return rutaCombinacionaDAO.busquedaTramoRutaOrigemDestino(ruta, origem, destino);
    }

    public List<RutaCombinacion> obtenerPorRuta(Ruta ruta) {
         return rutaCombinacionaDAO.obtenerPorRuta(ruta);
    }

     public boolean buscarRutaCombinacionExisteTramo(Tramo tramo) {
        return rutaCombinacionaDAO.buscarRutaCombinacionExisteTramo(tramo);
    }
     
     public int borrarCombinaciones(Ruta ruta){
    	 return rutaCombinacionaDAO.borrarCombinaciones(ruta);
     }
     @Transactional
     public void activar(Ruta ruta, Tramo trBuscaOrigemDestino){
    	 rutaCombinacionaDAO.activar(ruta, trBuscaOrigemDestino);
     }
}
